// Package models provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen/v2 version v2.1.0 DO NOT EDIT.
package models

import (
	"encoding/json"
	"errors"

	"github.com/oapi-codegen/runtime"
)

// Defines values for ActorType.
const (
	ACTORTYPESERVICE ActorType = "ACTOR_TYPE_SERVICE"
	ACTORTYPEUNKNOWN ActorType = "ACTOR_TYPE_UNKNOWN"
	ACTORTYPEUSER    ActorType = "ACTOR_TYPE_USER"
)

// Defines values for EventType.
const (
	EVENTTYPEACCEPTCONTRACT          EventType = "EVENT_TYPE_ACCEPT_CONTRACT"
	EVENTTYPECREATECONTRACT          EventType = "EVENT_TYPE_CREATE_CONTRACT"
	EVENTTYPECREATEPEER              EventType = "EVENT_TYPE_CREATE_PEER"
	EVENTTYPECREATESERVICE           EventType = "EVENT_TYPE_CREATE_SERVICE"
	EVENTTYPEDELETEPEER              EventType = "EVENT_TYPE_DELETE_PEER"
	EVENTTYPEDELETESERVICE           EventType = "EVENT_TYPE_DELETE_SERVICE"
	EVENTTYPEFAILEDDISTRIBUTIONRETRY EventType = "EVENT_TYPE_FAILED_DISTRIBUTION_RETRY"
	EVENTTYPELOGIN                   EventType = "EVENT_TYPE_LOGIN"
	EVENTTYPEREJECTCONTRACT          EventType = "EVENT_TYPE_REJECT_CONTRACT"
	EVENTTYPEREVOKECONTRACT          EventType = "EVENT_TYPE_REVOKE_CONTRACT"
	EVENTTYPESYNCHRONIZEPEERS        EventType = "EVENT_TYPE_SYNCHRONIZE_PEERS"
	EVENTTYPEUPDATEPEER              EventType = "EVENT_TYPE_UPDATE_PEER"
	EVENTTYPEUPDATESERVICE           EventType = "EVENT_TYPE_UPDATE_SERVICE"
)

// Defines values for FailedDistributionRetryAction.
const (
	SUBMITACCEPTSIGNATURE FailedDistributionRetryAction = "SUBMIT_ACCEPT_SIGNATURE"
	SUBMITCONTRACT        FailedDistributionRetryAction = "SUBMIT_CONTRACT"
	SUBMITREJECTSIGNATURE FailedDistributionRetryAction = "SUBMIT_REJECT_SIGNATURE"
	SUBMITREVOKESIGNATURE FailedDistributionRetryAction = "SUBMIT_REVOKE_SIGNATURE"
)

// Defines values for RecordComponent.
const (
	COMPONENTCONTROLLER RecordComponent = "COMPONENT_CONTROLLER"
	COMPONENTMANAGER    RecordComponent = "COMPONENT_MANAGER"
)

// Defines values for SortOrder.
const (
	SORTORDERASCENDING  SortOrder = "SORT_ORDER_ASCENDING"
	SORTORDERDESCENDING SortOrder = "SORT_ORDER_DESCENDING"
)

// Defines values for SourceType.
const (
	SOURCETYPEHTTP SourceType = "SOURCE_TYPE_HTTP"
)

// Defines values for StatusType.
const (
	STATUSTYPEFAILED       StatusType = "STATUS_TYPE_FAILED"
	STATUSTYPEINITIATED    StatusType = "STATUS_TYPE_INITIATED"
	STATUSTYPESUCCEEDED    StatusType = "STATUS_TYPE_SUCCEEDED"
	STATUSTYPEUNAUTHORIZED StatusType = "STATUS_TYPE_UNAUTHORIZED"
)

// ActorService Service that initiated the event
type ActorService struct {
	// PublicKeyThumbprint Public Key Thumbprint of the certificate used by the service
	PublicKeyThumbprint string `json:"public_key_thumbprint"`

	// SubjectCommonName Subject Common Name of the certificate used by the service
	SubjectCommonName string    `json:"subject_common_name"`
	Type              ActorType `json:"type"`
}

// ActorType defines model for actorType.
type ActorType string

// ActorUnknown Used when actor is unknown, e.g. when the event happened before authentication
type ActorUnknown struct {
	Type ActorType `json:"type"`
}

// ActorUser User that initiated the event
type ActorUser struct {
	// Email Email of the user
	Email string `json:"email"`

	// Name Name of the user
	Name string    `json:"name"`
	Type ActorType `json:"type"`
}

// ContentHash The hash of the Content of a Contract
type ContentHash = string

// Error Error object according to [RFC 9457](https://www.rfc-editor.org/rfc/rfc9457.html)
type Error struct {
	// Details Human-readable explanation specific to this occurrence of the problem.
	// The "detail" string, if present, ought to focus on helping the client correct the problem, rather than giving debugging information.
	Details string `json:"details"`

	// Instance URI reference that identifies the specific occurrence of the problem.
	Instance string `json:"instance"`

	// Status HTTP status code generated by the origin server for this occurrence of the problem.
	Status int `json:"status"`

	// Title Short, human-readable summary of the problem type.
	Title string `json:"title"`

	// Type URI reference that identifies the problem type.
	Type string `json:"type"`
}

// EventAcceptContract Event accept contract
type EventAcceptContract struct {
	// ContentHash The hash of the Content of a Contract
	ContentHash ContentHash `json:"content_hash"`
	Type        EventType   `json:"type"`
}

// EventCreateContract Event create contract
type EventCreateContract struct {
	// ContentHash The hash of the Content of a Contract
	ContentHash ContentHash `json:"content_hash"`
	Type        EventType   `json:"type"`
}

// EventCreatePeer Event create peer
type EventCreatePeer struct {
	// PeerId The ID of a Peer
	PeerId PeerID    `json:"peer_id"`
	Type   EventType `json:"type"`
}

// EventCreateService Event create service
type EventCreateService struct {
	// ServiceName The name of a service
	ServiceName ServiceName `json:"service_name"`
	Type        EventType   `json:"type"`
}

// EventDeletePeer Event delete peer
type EventDeletePeer struct {
	// PeerId The ID of a Peer
	PeerId PeerID    `json:"peer_id"`
	Type   EventType `json:"type"`
}

// EventDeleteService Event delete service
type EventDeleteService struct {
	// ServiceName The name of a service
	ServiceName ServiceName `json:"service_name"`
	Type        EventType   `json:"type"`
}

// EventFailedDistributionRetry Event failed distribution retry
type EventFailedDistributionRetry struct {
	Action FailedDistributionRetryAction `json:"action"`

	// ContentHash The hash of the Content of a Contract
	ContentHash ContentHash `json:"content_hash"`

	// PeerId The ID of a Peer
	PeerId PeerID    `json:"peer_id"`
	Type   EventType `json:"type"`
}

// EventLogin Event login
type EventLogin struct {
	Type EventType `json:"type"`
}

// EventRejectContract Event reject contract
type EventRejectContract struct {
	// ContentHash The hash of the Content of a Contract
	ContentHash ContentHash `json:"content_hash"`
	Type        EventType   `json:"type"`
}

// EventRevokeContract Event revoke contract
type EventRevokeContract struct {
	// ContentHash The hash of the Content of a Contract
	ContentHash ContentHash `json:"content_hash"`
	Type        EventType   `json:"type"`
}

// EventSynchronizePeers Event synchronize peers
type EventSynchronizePeers struct {
	Type EventType `json:"type"`
}

// EventType defines model for eventType.
type EventType string

// EventUpdatePeer Event update peer
type EventUpdatePeer struct {
	// PeerId The ID of a Peer
	PeerId PeerID    `json:"peer_id"`
	Type   EventType `json:"type"`
}

// EventUpdateService Event update service
type EventUpdateService struct {
	// ServiceName The name of a service
	ServiceName ServiceName `json:"service_name"`
	Type        EventType   `json:"type"`
}

// FailedDistributionRetryAction defines model for failedDistributionRetryAction.
type FailedDistributionRetryAction string

// GroupID The FSC Group ID (Directory URI)
type GroupID = string

// PaginationResult defines model for paginationResult.
type PaginationResult struct {
	// NextCursor A cursor that can be used to retrieve the next page or an empty string if there are no more results
	NextCursor string `json:"next_cursor"`
}

// PeerID The ID of a Peer
type PeerID = string

// Record A auditlog record
type Record struct {
	Actor Record_Actor `json:"actor"`

	// Component The component creating this record
	Component RecordComponent `json:"component"`

	// CorrelationId UUID v7
	CorrelationId Uuid `json:"correlation_id"`

	// CreatedAt A Unix timestamp
	CreatedAt Timestamp    `json:"created_at"`
	Event     Record_Event `json:"event"`

	// GroupId The FSC Group ID (Directory URI)
	GroupId GroupID `json:"group_id"`

	// Id UUID v7
	Id     Uuid          `json:"id"`
	Source Record_Source `json:"source"`
	Status Record_Status `json:"status"`

	// UnderReviewAt A Unix timestamp
	UnderReviewAt *Timestamp `json:"under_review_at,omitempty"`
}

// Record_Actor defines model for Record.Actor.
type Record_Actor struct {
	union json.RawMessage
}

// RecordComponent The component creating this record
type RecordComponent string

// Record_Event defines model for Record.Event.
type Record_Event struct {
	union json.RawMessage
}

// Record_Source defines model for Record.Source.
type Record_Source struct {
	union json.RawMessage
}

// Record_Status defines model for Record.Status.
type Record_Status struct {
	union json.RawMessage
}

// ServiceName The name of a service
type ServiceName = string

// SortOrder The order in which the results should be returned
type SortOrder string

// SourceHttp Info about the http source of the event
type SourceHttp struct {
	// IpAddress IP address of the request
	IpAddress string     `json:"ip_address"`
	Type      SourceType `json:"type"`

	// UserAgent User agent of the request
	UserAgent string `json:"user_agent"`
}

// SourceType defines model for sourceType.
type SourceType string

// StatusFailed Status failed
type StatusFailed struct {
	// Error Description of the error
	Error string     `json:"error"`
	Type  StatusType `json:"type"`
}

// StatusInitiated Status initiated
type StatusInitiated struct {
	Type StatusType `json:"type"`
}

// StatusSucceeded Status succeeded
type StatusSucceeded struct {
	Type StatusType `json:"type"`
}

// StatusType defines model for statusType.
type StatusType string

// StatusUnauthorized Status unauthorized
type StatusUnauthorized struct {
	// Error Description of the error
	Error string     `json:"error"`
	Type  StatusType `json:"type"`
}

// Timestamp A Unix timestamp
type Timestamp = int64

// Uuid UUID v7
type Uuid = string

// QueryPaginationCursor defines model for queryPaginationCursor.
type QueryPaginationCursor = string

// QueryPaginationLimit defines model for queryPaginationLimit.
type QueryPaginationLimit = uint32

// QueryPaginationOrder The order in which the results should be returned
type QueryPaginationOrder = SortOrder

// N400BadRequest Error object according to [RFC 9457](https://www.rfc-editor.org/rfc/rfc9457.html)
type N400BadRequest = Error

// N401Unauthorized Error object according to [RFC 9457](https://www.rfc-editor.org/rfc/rfc9457.html)
type N401Unauthorized = Error

// N403Forbidden Error object according to [RFC 9457](https://www.rfc-editor.org/rfc/rfc9457.html)
type N403Forbidden = Error

// N404NotFound Error object according to [RFC 9457](https://www.rfc-editor.org/rfc/rfc9457.html)
type N404NotFound = Error

// N408RequestTimeout Error object according to [RFC 9457](https://www.rfc-editor.org/rfc/rfc9457.html)
type N408RequestTimeout = Error

// N413PayloadTooLarge Error object according to [RFC 9457](https://www.rfc-editor.org/rfc/rfc9457.html)
type N413PayloadTooLarge = Error

// N414URITooLong Error object according to [RFC 9457](https://www.rfc-editor.org/rfc/rfc9457.html)
type N414URITooLong = Error

// N422UnprocessableEntity Error object according to [RFC 9457](https://www.rfc-editor.org/rfc/rfc9457.html)
type N422UnprocessableEntity = Error

// N429TooManyRequests Error object according to [RFC 9457](https://www.rfc-editor.org/rfc/rfc9457.html)
type N429TooManyRequests = Error

// N431RequestHeaderFieldsTooLarge Error object according to [RFC 9457](https://www.rfc-editor.org/rfc/rfc9457.html)
type N431RequestHeaderFieldsTooLarge = Error

// N500InternalServerError Error object according to [RFC 9457](https://www.rfc-editor.org/rfc/rfc9457.html)
type N500InternalServerError = Error

// N503ServiceUnavailable Error object according to [RFC 9457](https://www.rfc-editor.org/rfc/rfc9457.html)
type N503ServiceUnavailable = Error

// N505HTTPVersionNotSupported Error object according to [RFC 9457](https://www.rfc-editor.org/rfc/rfc9457.html)
type N505HTTPVersionNotSupported = Error

// GetRecordsParams defines parameters for GetRecords.
type GetRecordsParams struct {
	// Cursor A cursor from which paginated results should be returned. Leave empty for the first page. Base64 encoded string of two properties: a created_at as unix timestamp and a content hash separated by a comma. Eg. `base64(1672527600,$1$1$+PQI7we01qIfEwq4O5UioLKzjGBgRva6F5+bUfDlKxUjcY5yX1MRsn6NKquDbL8VcklhYO9sk18rHD6La3w/mg)
	Cursor *QueryPaginationCursor `form:"cursor,omitempty" json:"cursor,omitempty"`

	// Limit The maximum number of results
	Limit *QueryPaginationLimit `form:"limit,omitempty" json:"limit,omitempty"`

	// SortOrder The sorting order of the results
	SortOrder *QueryPaginationOrder `form:"sort_order,omitempty" json:"sort_order,omitempty"`

	// After Auditlog records with a creation date after this value will be returned
	After *Timestamp `form:"after,omitempty" json:"after,omitempty"`

	// Before Auditlog records with a creation date before this value will be returned
	Before *Timestamp `form:"before,omitempty" json:"before,omitempty"`

	// GroupId Get the auditlog records for this group.
	GroupId GroupID `form:"group_id" json:"group_id"`

	// Id A list of IDs on which to filter. When this filter is used, all other filters should be ignored
	Id *[]Uuid `form:"id,omitempty" json:"id,omitempty"`

	// CorrelationId A list of Correlation IDs on which to filter. When this filter is used, all other filters should be ignored
	CorrelationId *[]Uuid `form:"correlation_id,omitempty" json:"correlation_id,omitempty"`

	// ContentHash A list of content hashes on which to filter, e.g. events which contain these content hashes. When multiple filters are used the records where either condition is true should be returned
	ContentHash *[]ContentHash `form:"content_hash,omitempty" json:"content_hash,omitempty"`

	// ServiceName A list of service names on which to filter, e.g. events which contain these service names. When multiple filters are used the records where either condition is true should be returned
	ServiceName *[]ServiceName `form:"service_name,omitempty" json:"service_name,omitempty"`

	// UnderReview When true only list records that are under review
	UnderReview *bool `form:"under_review,omitempty" json:"under_review,omitempty"`
}

// CreateRecordsJSONBody defines parameters for CreateRecords.
type CreateRecordsJSONBody struct {
	// Records List of auditlog records to create
	Records []Record `json:"records"`
}

// UnsetRecordsUnderReviewJSONBody defines parameters for UnsetRecordsUnderReview.
type UnsetRecordsUnderReviewJSONBody struct {
	// Ids A list of IDs of the records that needs to be unset under review
	Ids []Uuid `json:"ids"`
}

// SetRecordsUnderReviewJSONBody defines parameters for SetRecordsUnderReview.
type SetRecordsUnderReviewJSONBody struct {
	// Ids A list of IDs of the records that needs to be set under review
	Ids []Uuid `json:"ids"`
}

// CreateRecordsJSONRequestBody defines body for CreateRecords for application/json ContentType.
type CreateRecordsJSONRequestBody CreateRecordsJSONBody

// UnsetRecordsUnderReviewJSONRequestBody defines body for UnsetRecordsUnderReview for application/json ContentType.
type UnsetRecordsUnderReviewJSONRequestBody UnsetRecordsUnderReviewJSONBody

// SetRecordsUnderReviewJSONRequestBody defines body for SetRecordsUnderReview for application/json ContentType.
type SetRecordsUnderReviewJSONRequestBody SetRecordsUnderReviewJSONBody

// AsActorUnknown returns the union data inside the Record_Actor as a ActorUnknown
func (t Record_Actor) AsActorUnknown() (ActorUnknown, error) {
	var body ActorUnknown
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromActorUnknown overwrites any union data inside the Record_Actor as the provided ActorUnknown
func (t *Record_Actor) FromActorUnknown(v ActorUnknown) error {
	v.Type = "ACTOR_TYPE_UNKNOWN"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeActorUnknown performs a merge with any union data inside the Record_Actor, using the provided ActorUnknown
func (t *Record_Actor) MergeActorUnknown(v ActorUnknown) error {
	v.Type = "ACTOR_TYPE_UNKNOWN"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsActorUser returns the union data inside the Record_Actor as a ActorUser
func (t Record_Actor) AsActorUser() (ActorUser, error) {
	var body ActorUser
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromActorUser overwrites any union data inside the Record_Actor as the provided ActorUser
func (t *Record_Actor) FromActorUser(v ActorUser) error {
	v.Type = "ACTOR_TYPE_USER"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeActorUser performs a merge with any union data inside the Record_Actor, using the provided ActorUser
func (t *Record_Actor) MergeActorUser(v ActorUser) error {
	v.Type = "ACTOR_TYPE_USER"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsActorService returns the union data inside the Record_Actor as a ActorService
func (t Record_Actor) AsActorService() (ActorService, error) {
	var body ActorService
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromActorService overwrites any union data inside the Record_Actor as the provided ActorService
func (t *Record_Actor) FromActorService(v ActorService) error {
	v.Type = "ACTOR_TYPE_SERVICE"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeActorService performs a merge with any union data inside the Record_Actor, using the provided ActorService
func (t *Record_Actor) MergeActorService(v ActorService) error {
	v.Type = "ACTOR_TYPE_SERVICE"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

func (t Record_Actor) Discriminator() (string, error) {
	var discriminator struct {
		Discriminator string `json:"type"`
	}
	err := json.Unmarshal(t.union, &discriminator)
	return discriminator.Discriminator, err
}

func (t Record_Actor) ValueByDiscriminator() (interface{}, error) {
	discriminator, err := t.Discriminator()
	if err != nil {
		return nil, err
	}
	switch discriminator {
	case "ACTOR_TYPE_SERVICE":
		return t.AsActorService()
	case "ACTOR_TYPE_UNKNOWN":
		return t.AsActorUnknown()
	case "ACTOR_TYPE_USER":
		return t.AsActorUser()
	default:
		return nil, errors.New("unknown discriminator value: " + discriminator)
	}
}

func (t Record_Actor) MarshalJSON() ([]byte, error) {
	b, err := t.union.MarshalJSON()
	return b, err
}

func (t *Record_Actor) UnmarshalJSON(b []byte) error {
	err := t.union.UnmarshalJSON(b)
	return err
}

// AsEventLogin returns the union data inside the Record_Event as a EventLogin
func (t Record_Event) AsEventLogin() (EventLogin, error) {
	var body EventLogin
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromEventLogin overwrites any union data inside the Record_Event as the provided EventLogin
func (t *Record_Event) FromEventLogin(v EventLogin) error {
	v.Type = "EVENT_TYPE_LOGIN"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeEventLogin performs a merge with any union data inside the Record_Event, using the provided EventLogin
func (t *Record_Event) MergeEventLogin(v EventLogin) error {
	v.Type = "EVENT_TYPE_LOGIN"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsEventCreateContract returns the union data inside the Record_Event as a EventCreateContract
func (t Record_Event) AsEventCreateContract() (EventCreateContract, error) {
	var body EventCreateContract
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromEventCreateContract overwrites any union data inside the Record_Event as the provided EventCreateContract
func (t *Record_Event) FromEventCreateContract(v EventCreateContract) error {
	v.Type = "EVENT_TYPE_CREATE_CONTRACT"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeEventCreateContract performs a merge with any union data inside the Record_Event, using the provided EventCreateContract
func (t *Record_Event) MergeEventCreateContract(v EventCreateContract) error {
	v.Type = "EVENT_TYPE_CREATE_CONTRACT"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsEventAcceptContract returns the union data inside the Record_Event as a EventAcceptContract
func (t Record_Event) AsEventAcceptContract() (EventAcceptContract, error) {
	var body EventAcceptContract
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromEventAcceptContract overwrites any union data inside the Record_Event as the provided EventAcceptContract
func (t *Record_Event) FromEventAcceptContract(v EventAcceptContract) error {
	v.Type = "EVENT_TYPE_ACCEPT_CONTRACT"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeEventAcceptContract performs a merge with any union data inside the Record_Event, using the provided EventAcceptContract
func (t *Record_Event) MergeEventAcceptContract(v EventAcceptContract) error {
	v.Type = "EVENT_TYPE_ACCEPT_CONTRACT"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsEventRejectContract returns the union data inside the Record_Event as a EventRejectContract
func (t Record_Event) AsEventRejectContract() (EventRejectContract, error) {
	var body EventRejectContract
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromEventRejectContract overwrites any union data inside the Record_Event as the provided EventRejectContract
func (t *Record_Event) FromEventRejectContract(v EventRejectContract) error {
	v.Type = "EVENT_TYPE_REJECT_CONTRACT"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeEventRejectContract performs a merge with any union data inside the Record_Event, using the provided EventRejectContract
func (t *Record_Event) MergeEventRejectContract(v EventRejectContract) error {
	v.Type = "EVENT_TYPE_REJECT_CONTRACT"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsEventRevokeContract returns the union data inside the Record_Event as a EventRevokeContract
func (t Record_Event) AsEventRevokeContract() (EventRevokeContract, error) {
	var body EventRevokeContract
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromEventRevokeContract overwrites any union data inside the Record_Event as the provided EventRevokeContract
func (t *Record_Event) FromEventRevokeContract(v EventRevokeContract) error {
	v.Type = "EVENT_TYPE_REVOKE_CONTRACT"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeEventRevokeContract performs a merge with any union data inside the Record_Event, using the provided EventRevokeContract
func (t *Record_Event) MergeEventRevokeContract(v EventRevokeContract) error {
	v.Type = "EVENT_TYPE_REVOKE_CONTRACT"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsEventCreateService returns the union data inside the Record_Event as a EventCreateService
func (t Record_Event) AsEventCreateService() (EventCreateService, error) {
	var body EventCreateService
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromEventCreateService overwrites any union data inside the Record_Event as the provided EventCreateService
func (t *Record_Event) FromEventCreateService(v EventCreateService) error {
	v.Type = "EVENT_TYPE_CREATE_SERVICE"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeEventCreateService performs a merge with any union data inside the Record_Event, using the provided EventCreateService
func (t *Record_Event) MergeEventCreateService(v EventCreateService) error {
	v.Type = "EVENT_TYPE_CREATE_SERVICE"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsEventUpdateService returns the union data inside the Record_Event as a EventUpdateService
func (t Record_Event) AsEventUpdateService() (EventUpdateService, error) {
	var body EventUpdateService
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromEventUpdateService overwrites any union data inside the Record_Event as the provided EventUpdateService
func (t *Record_Event) FromEventUpdateService(v EventUpdateService) error {
	v.Type = "EVENT_TYPE_UPDATE_SERVICE"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeEventUpdateService performs a merge with any union data inside the Record_Event, using the provided EventUpdateService
func (t *Record_Event) MergeEventUpdateService(v EventUpdateService) error {
	v.Type = "EVENT_TYPE_UPDATE_SERVICE"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsEventDeleteService returns the union data inside the Record_Event as a EventDeleteService
func (t Record_Event) AsEventDeleteService() (EventDeleteService, error) {
	var body EventDeleteService
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromEventDeleteService overwrites any union data inside the Record_Event as the provided EventDeleteService
func (t *Record_Event) FromEventDeleteService(v EventDeleteService) error {
	v.Type = "EVENT_TYPE_DELETE_SERVICE"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeEventDeleteService performs a merge with any union data inside the Record_Event, using the provided EventDeleteService
func (t *Record_Event) MergeEventDeleteService(v EventDeleteService) error {
	v.Type = "EVENT_TYPE_DELETE_SERVICE"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsEventFailedDistributionRetry returns the union data inside the Record_Event as a EventFailedDistributionRetry
func (t Record_Event) AsEventFailedDistributionRetry() (EventFailedDistributionRetry, error) {
	var body EventFailedDistributionRetry
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromEventFailedDistributionRetry overwrites any union data inside the Record_Event as the provided EventFailedDistributionRetry
func (t *Record_Event) FromEventFailedDistributionRetry(v EventFailedDistributionRetry) error {
	v.Type = "EVENT_TYPE_FAILED_DISTRIBUTION_RETRY"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeEventFailedDistributionRetry performs a merge with any union data inside the Record_Event, using the provided EventFailedDistributionRetry
func (t *Record_Event) MergeEventFailedDistributionRetry(v EventFailedDistributionRetry) error {
	v.Type = "EVENT_TYPE_FAILED_DISTRIBUTION_RETRY"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsEventCreatePeer returns the union data inside the Record_Event as a EventCreatePeer
func (t Record_Event) AsEventCreatePeer() (EventCreatePeer, error) {
	var body EventCreatePeer
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromEventCreatePeer overwrites any union data inside the Record_Event as the provided EventCreatePeer
func (t *Record_Event) FromEventCreatePeer(v EventCreatePeer) error {
	v.Type = "EVENT_TYPE_CREATE_PEER"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeEventCreatePeer performs a merge with any union data inside the Record_Event, using the provided EventCreatePeer
func (t *Record_Event) MergeEventCreatePeer(v EventCreatePeer) error {
	v.Type = "EVENT_TYPE_CREATE_PEER"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsEventUpdatePeer returns the union data inside the Record_Event as a EventUpdatePeer
func (t Record_Event) AsEventUpdatePeer() (EventUpdatePeer, error) {
	var body EventUpdatePeer
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromEventUpdatePeer overwrites any union data inside the Record_Event as the provided EventUpdatePeer
func (t *Record_Event) FromEventUpdatePeer(v EventUpdatePeer) error {
	v.Type = "EVENT_TYPE_UPDATE_PEER"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeEventUpdatePeer performs a merge with any union data inside the Record_Event, using the provided EventUpdatePeer
func (t *Record_Event) MergeEventUpdatePeer(v EventUpdatePeer) error {
	v.Type = "EVENT_TYPE_UPDATE_PEER"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsEventDeletePeer returns the union data inside the Record_Event as a EventDeletePeer
func (t Record_Event) AsEventDeletePeer() (EventDeletePeer, error) {
	var body EventDeletePeer
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromEventDeletePeer overwrites any union data inside the Record_Event as the provided EventDeletePeer
func (t *Record_Event) FromEventDeletePeer(v EventDeletePeer) error {
	v.Type = "EVENT_TYPE_DELETE_PEER"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeEventDeletePeer performs a merge with any union data inside the Record_Event, using the provided EventDeletePeer
func (t *Record_Event) MergeEventDeletePeer(v EventDeletePeer) error {
	v.Type = "EVENT_TYPE_DELETE_PEER"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsEventSynchronizePeers returns the union data inside the Record_Event as a EventSynchronizePeers
func (t Record_Event) AsEventSynchronizePeers() (EventSynchronizePeers, error) {
	var body EventSynchronizePeers
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromEventSynchronizePeers overwrites any union data inside the Record_Event as the provided EventSynchronizePeers
func (t *Record_Event) FromEventSynchronizePeers(v EventSynchronizePeers) error {
	v.Type = "EVENT_TYPE_SYNCHRONIZE_PEERS"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeEventSynchronizePeers performs a merge with any union data inside the Record_Event, using the provided EventSynchronizePeers
func (t *Record_Event) MergeEventSynchronizePeers(v EventSynchronizePeers) error {
	v.Type = "EVENT_TYPE_SYNCHRONIZE_PEERS"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

func (t Record_Event) Discriminator() (string, error) {
	var discriminator struct {
		Discriminator string `json:"type"`
	}
	err := json.Unmarshal(t.union, &discriminator)
	return discriminator.Discriminator, err
}

func (t Record_Event) ValueByDiscriminator() (interface{}, error) {
	discriminator, err := t.Discriminator()
	if err != nil {
		return nil, err
	}
	switch discriminator {
	case "EVENT_TYPE_ACCEPT_CONTRACT":
		return t.AsEventAcceptContract()
	case "EVENT_TYPE_CREATE_CONTRACT":
		return t.AsEventCreateContract()
	case "EVENT_TYPE_CREATE_PEER":
		return t.AsEventCreatePeer()
	case "EVENT_TYPE_CREATE_SERVICE":
		return t.AsEventCreateService()
	case "EVENT_TYPE_DELETE_PEER":
		return t.AsEventDeletePeer()
	case "EVENT_TYPE_DELETE_SERVICE":
		return t.AsEventDeleteService()
	case "EVENT_TYPE_FAILED_DISTRIBUTION_RETRY":
		return t.AsEventFailedDistributionRetry()
	case "EVENT_TYPE_LOGIN":
		return t.AsEventLogin()
	case "EVENT_TYPE_REJECT_CONTRACT":
		return t.AsEventRejectContract()
	case "EVENT_TYPE_REVOKE_CONTRACT":
		return t.AsEventRevokeContract()
	case "EVENT_TYPE_SYNCHRONIZE_PEERS":
		return t.AsEventSynchronizePeers()
	case "EVENT_TYPE_UPDATE_PEER":
		return t.AsEventUpdatePeer()
	case "EVENT_TYPE_UPDATE_SERVICE":
		return t.AsEventUpdateService()
	default:
		return nil, errors.New("unknown discriminator value: " + discriminator)
	}
}

func (t Record_Event) MarshalJSON() ([]byte, error) {
	b, err := t.union.MarshalJSON()
	return b, err
}

func (t *Record_Event) UnmarshalJSON(b []byte) error {
	err := t.union.UnmarshalJSON(b)
	return err
}

// AsSourceHttp returns the union data inside the Record_Source as a SourceHttp
func (t Record_Source) AsSourceHttp() (SourceHttp, error) {
	var body SourceHttp
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromSourceHttp overwrites any union data inside the Record_Source as the provided SourceHttp
func (t *Record_Source) FromSourceHttp(v SourceHttp) error {
	v.Type = "SOURCE_TYPE_HTTP"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeSourceHttp performs a merge with any union data inside the Record_Source, using the provided SourceHttp
func (t *Record_Source) MergeSourceHttp(v SourceHttp) error {
	v.Type = "SOURCE_TYPE_HTTP"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

func (t Record_Source) Discriminator() (string, error) {
	var discriminator struct {
		Discriminator string `json:"type"`
	}
	err := json.Unmarshal(t.union, &discriminator)
	return discriminator.Discriminator, err
}

func (t Record_Source) ValueByDiscriminator() (interface{}, error) {
	discriminator, err := t.Discriminator()
	if err != nil {
		return nil, err
	}
	switch discriminator {
	case "SOURCE_TYPE_HTTP":
		return t.AsSourceHttp()
	default:
		return nil, errors.New("unknown discriminator value: " + discriminator)
	}
}

func (t Record_Source) MarshalJSON() ([]byte, error) {
	b, err := t.union.MarshalJSON()
	return b, err
}

func (t *Record_Source) UnmarshalJSON(b []byte) error {
	err := t.union.UnmarshalJSON(b)
	return err
}

// AsStatusInitiated returns the union data inside the Record_Status as a StatusInitiated
func (t Record_Status) AsStatusInitiated() (StatusInitiated, error) {
	var body StatusInitiated
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromStatusInitiated overwrites any union data inside the Record_Status as the provided StatusInitiated
func (t *Record_Status) FromStatusInitiated(v StatusInitiated) error {
	v.Type = "STATUS_TYPE_INITIATED"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeStatusInitiated performs a merge with any union data inside the Record_Status, using the provided StatusInitiated
func (t *Record_Status) MergeStatusInitiated(v StatusInitiated) error {
	v.Type = "STATUS_TYPE_INITIATED"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsStatusFailed returns the union data inside the Record_Status as a StatusFailed
func (t Record_Status) AsStatusFailed() (StatusFailed, error) {
	var body StatusFailed
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromStatusFailed overwrites any union data inside the Record_Status as the provided StatusFailed
func (t *Record_Status) FromStatusFailed(v StatusFailed) error {
	v.Type = "STATUS_TYPE_FAILED"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeStatusFailed performs a merge with any union data inside the Record_Status, using the provided StatusFailed
func (t *Record_Status) MergeStatusFailed(v StatusFailed) error {
	v.Type = "STATUS_TYPE_FAILED"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsStatusUnauthorized returns the union data inside the Record_Status as a StatusUnauthorized
func (t Record_Status) AsStatusUnauthorized() (StatusUnauthorized, error) {
	var body StatusUnauthorized
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromStatusUnauthorized overwrites any union data inside the Record_Status as the provided StatusUnauthorized
func (t *Record_Status) FromStatusUnauthorized(v StatusUnauthorized) error {
	v.Type = "STATUS_TYPE_UNAUTHORIZED"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeStatusUnauthorized performs a merge with any union data inside the Record_Status, using the provided StatusUnauthorized
func (t *Record_Status) MergeStatusUnauthorized(v StatusUnauthorized) error {
	v.Type = "STATUS_TYPE_UNAUTHORIZED"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

// AsStatusSucceeded returns the union data inside the Record_Status as a StatusSucceeded
func (t Record_Status) AsStatusSucceeded() (StatusSucceeded, error) {
	var body StatusSucceeded
	err := json.Unmarshal(t.union, &body)
	return body, err
}

// FromStatusSucceeded overwrites any union data inside the Record_Status as the provided StatusSucceeded
func (t *Record_Status) FromStatusSucceeded(v StatusSucceeded) error {
	v.Type = "STATUS_TYPE_SUCCEEDED"
	b, err := json.Marshal(v)
	t.union = b
	return err
}

// MergeStatusSucceeded performs a merge with any union data inside the Record_Status, using the provided StatusSucceeded
func (t *Record_Status) MergeStatusSucceeded(v StatusSucceeded) error {
	v.Type = "STATUS_TYPE_SUCCEEDED"
	b, err := json.Marshal(v)
	if err != nil {
		return err
	}

	merged, err := runtime.JSONMerge(t.union, b)
	t.union = merged
	return err
}

func (t Record_Status) Discriminator() (string, error) {
	var discriminator struct {
		Discriminator string `json:"type"`
	}
	err := json.Unmarshal(t.union, &discriminator)
	return discriminator.Discriminator, err
}

func (t Record_Status) ValueByDiscriminator() (interface{}, error) {
	discriminator, err := t.Discriminator()
	if err != nil {
		return nil, err
	}
	switch discriminator {
	case "STATUS_TYPE_FAILED":
		return t.AsStatusFailed()
	case "STATUS_TYPE_INITIATED":
		return t.AsStatusInitiated()
	case "STATUS_TYPE_SUCCEEDED":
		return t.AsStatusSucceeded()
	case "STATUS_TYPE_UNAUTHORIZED":
		return t.AsStatusUnauthorized()
	default:
		return nil, errors.New("unknown discriminator value: " + discriminator)
	}
}

func (t Record_Status) MarshalJSON() ([]byte, error) {
	b, err := t.union.MarshalJSON()
	return b, err
}

func (t *Record_Status) UnmarshalJSON(b []byte) error {
	err := t.union.UnmarshalJSON(b)
	return err
}
